package com.gxwebsoft.shop.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gxwebsoft.shop.mapper.UserAddressMapper;
import com.gxwebsoft.shop.service.UserAddressService;
import com.gxwebsoft.shop.entity.UserAddress;
import com.gxwebsoft.shop.param.UserAddressParam;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.PageResult;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 用户收货地址表Service实现
 *
 * @author 科技小王子
 * @since 2022-11-25 19:04:43
 */
@Service
public class UserAddressServiceImpl extends ServiceImpl<UserAddressMapper, UserAddress> implements UserAddressService {

    @Override
    public PageResult<UserAddress> pageRel(UserAddressParam param) {
        PageParam<UserAddress, UserAddressParam> page = new PageParam<>(param);
        //page.setDefaultOrder("create_time desc");
        List<UserAddress> list = baseMapper.selectPageRel(page, param);
        return new PageResult<>(list, page.getTotal());
    }

    @Override
    public List<UserAddress> listRel(UserAddressParam param) {
        List<UserAddress> list = baseMapper.selectListRel(param);
        // 排序
        PageParam<UserAddress, UserAddressParam> page = new PageParam<>();
        //page.setDefaultOrder("create_time desc");
        return page.sortRecords(list);
    }

    @Override
    public UserAddress getByIdRel(Integer addressId) {
        UserAddressParam param = new UserAddressParam();
        param.setAddressId(addressId);
        return param.getOne(baseMapper.selectListRel(param));
    }

}
